﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using System.Text.RegularExpressions;

namespace Preprocesiranje
{
    class Region{
        public Region(int pocetak, int kraj, bool komplament)
        {
            this.pocetak = pocetak;
            this.kraj = kraj;
            this.komplament = komplament;
        }

        public int pocetak;
        public int kraj;
        public bool komplament = false;
        public string gen;
    }

    class PrevodilacFormata
    {

        public static List<Region> prebaciIzGenBankFormataMeta(String genBankMetaPutanja)
        {
            string[] ulazneLinije = File.ReadAllLines(genBankMetaPutanja);
            List<Region> meta = new List<Region>();
            char[] sep1={' ','\t','/','=','"'};
            char[] sep2={' ','\t','(',')','.'};
            string l;
            for (int i = 0; i < ulazneLinije.Length; i++)
            {
                l = ulazneLinije[i];
                if (l.Trim().StartsWith("gene"))
                {
                    Region r;
                    string[] tokeni = l.Split(sep2).Where(x=>x!="").ToArray();
                    if (tokeni[1] == "complement")
                    {
                        r = new Region(Convert.ToInt32(tokeni[2]), Convert.ToInt32(tokeni[3]), true);
                    }
                    else
                    {
                        r = new Region(Convert.ToInt32(tokeni[1]), Convert.ToInt32(tokeni[2]), false);
                    }
                    l = ulazneLinije[++i];
                    tokeni = l.Split(sep1).Where(x=>x!="").ToArray();
                    r.gen = tokeni[1];
                    meta.Add(r);
                }
            }
            return meta;
        }



        public static void prebaciIzGenBankFormataData(String genBankPutanja, List<Region> regioni, String izlaznaPutanja, int idOrganizma)
        {
            StringBuilder tekstLined = new StringBuilder();
            StringBuilder tekstPlain = new StringBuilder();
            string izlaznaPutanjaGeni = izlaznaPutanja + ".geni";
            string izlaznaPutanjaKodoni = izlaznaPutanja + ".kodoni";
            string tekstPlainStr;
            StringBuilder kod;
            char c;
            string[] genomTekst = File.ReadAllLines(genBankPutanja);

            for (int i = 0; i < genomTekst.Length; i++)
            {
                string[] tokeni = genomTekst[i].Split(new char[]{' ','\t'}).Where(x => x != "").ToArray();
                kod = new StringBuilder();
                for (int k = 1; k < tokeni.Length; k++)
                    kod.Append(tokeni[k]);
                int rbr = Convert.ToInt32(tokeni[0]);
                int j = 0;
                int error=rbr - (i * 60 + 1);
                if (error > 0)
                    error = error;
                while((j < 60 && i<(genomTekst.Length-1)) || (i==(genomTekst.Length-1) && j<kod.Length))
                {
                    c = kod[j];
                    /*
                    if (c == 'a' || c == 'c' || c == 't' || c == 'g' || c == 'k' || c == 'y')
                    {
                        tekstLined.AppendLine(c.ToString());
                        tekstPlain.Append(c.ToString());
                        j++;
                    }
                    else
                    {
                        tekstLined.AppendLine("x");
                        tekstPlain.Append("x");
                        j++;
                    }
                     * */
                    tekstLined.AppendLine(c.ToString());
                    tekstPlain.Append(c.ToString());
                    j++;
                }
            }
           
            tekstPlainStr = tekstPlain.ToString();
         //   File.WriteAllText(izlaznaPutanja+".line", tekstLined.ToString());
            StringBuilder izlazGeni = new StringBuilder();
            StringBuilder izlazKodoni = new StringBuilder();
            string gen;
            foreach (Region r in regioni)
            {
                gen = tekstPlainStr.ToString().Substring(r.pocetak - 1, (r.kraj - r.pocetak));
                //izlazGeni.AppendLine("INSERT INTO GEN(NAZIV, KOMPLAMENT, POCETAK, KRAJ, KOD) VALUES ('" + r.gen + "', '" + (r.komplament ? "1" : "0") + "'," + r.pocetak + ", " + r.kraj + ",'" + gen + "');");
                izlazGeni.AppendLine("'" + r.gen + "', '" + (r.komplament ? "1" : "0") + "'," + r.pocetak + ", " + r.kraj + ",'" + gen + "', "+idOrganizma);
                for (int i = 0; i < (r.kraj - r.pocetak) / 3; i++)
                {
                    //delimo na kodone
                 //   izlazKodoni.AppendLine("INSERT INTO KODON(KOMPLAMENT, POCETAK, KODON, POCETAK_GENA, KRAJ_GENA) VALUES ('" + (r.komplament ? "1" : "0") + "', "+(r.pocetak+i*3) + ",'" + gen.Substring(i*3,3) + "', "+r.pocetak+", "+r.kraj+ ");");
                    izlazKodoni.AppendLine("1,\"" + (r.komplament ? "1" : "0") + "\", " + (r.pocetak + i * 3) + ",\"" + gen.Substring(i * 3, 3) + "\", " + r.pocetak + ", " + r.kraj+", "+idOrganizma);
                }
            }
            File.WriteAllText(izlaznaPutanjaGeni, izlazGeni.ToString());
            File.WriteAllText(izlaznaPutanjaKodoni, izlazKodoni.ToString());
        }
    }
}
